#include <amxmodx>
#include <amxmisc>
#include <hamsandwich>
#include <cstrike>
#include <nvault>

new money[33]
new vault
new bool:joined[33]
new bool:transfering[33]

new cvar_maxmoney

public plugin_init()
{
	register_plugin("Money Manager", "1.0", "Lucky")
	
	register_event("Money", "updatemoney", "b")
	
	register_clcmd("say", "handle_say")
	register_clcmd("say_team", "handle_say")
	
	cvar_maxmoney = register_cvar("amx_maxmoney", "99999")
	
	RegisterHam(Ham_Spawn, "player", "player_spawn", 1)
}

public plugin_cfg()
{
	vault = nvault_open("save_money")
}

public plugin_end()
{
	nvault_close(vault)
}

public client_putinserver(id)
{
	new authid[32]
	get_user_authid(id, authid, 31)
	money[id] = nvault_get(vault, authid)
	if(!money[id])
	{
		nvault_touch(vault, authid)
		money[id] = get_cvar_num("mp_startmoney")
		new smoney[11]
		num_to_str(money[id], smoney, 10)
		nvault_set(vault, authid, smoney)
	}
	joined[id] = false
	transfering[id] = false
	set_task(60.0, "check_money_msg", id+100, _, _, "b")
}

public player_spawn(id)
{
	if(!joined[id])
	{
		set_task(0.2, "task_setmoney", id)
		joined[id] = true
	}
}

public task_setmoney(id)
{
	if(money[id] <= 8000)
	{
		cs_set_user_money(id, money[id])
	}
	else
	{
		cs_set_user_money(id, 8000)
		update_hud_money(id, money[id], 0)
	}
}

public check_money_msg(iid)
{
	new id = iid-100
	if(money[id] < get_cvar_num("mp_startmoney"))
	{
		colorchat(id, "!t[Money Manager] !gYou have too little money.")
		colorchat(id, "!t[Money Manager] !gTo ask teammates for transfering money to you !nsay !t/money")
	}
}

public client_disconnect(id)
{
	new authid[32]
	get_user_authid(id, authid, 31)
	new smoney[11]
	num_to_str(money[id], smoney, 10)
	nvault_set(vault, authid, smoney)
	money[id] = 0
	remove_task(id+100)
}

public updatemoney(id)
{
	if(!joined[id] && !transfering[id])
	{
		cs_set_user_money(id, 0)
	}
	else if(joined[id] && !transfering[id])
	{
		new current = read_data(1)
		if(money[id] <= 8000)
		{
			money[id] = current
			if(money[id] > get_pcvar_num(cvar_maxmoney))
			{
				money[id] = get_pcvar_num(cvar_maxmoney)
			}
			cs_set_user_money(id, money[id])
			update_hud_money(id, current - money[id], 1)
			update_hud_money(id, money[id], 0)
		}
		else
		{
			money[id] += current - 8000
			if(money[id] > get_pcvar_num(cvar_maxmoney))
			{
				money[id] = get_pcvar_num(cvar_maxmoney)
			}
			cs_set_user_money(id, 8000)
			update_hud_money(id, current - 8000, 1)
			update_hud_money(id, money[id], 0)
		}
	}
}

update_hud_money(id, user_money, flash)
{
	message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("Money"), {0,0,0}, id)
	write_long(user_money)
	write_byte(flash)
	message_end()
}

public handle_say(id)
{
	new arg[32]
	read_argv(1, arg, 31)
	new temp[10]
	copy(temp, 6, arg)
	if(equali(temp, "/money"))
	{
		new name[65]
		get_user_name(id, name, 64)
		new maxpl = get_maxplayers()
		for(new i = 1; i <= maxpl; i++)
		{
			if(get_user_team(i) == get_user_team(id) && money[i] > money[id])
			{
				colorchat(i, "!t[Money Manager] !t%s !ghave only !t$%i!g, transfer money to him: !nsay !g/transfer", name, money[id])
			}
		}
		return PLUGIN_HANDLED
	}
	copy(temp, 9, arg)
	if(equali(temp, "/transfer"))
	{
		new args[101], arg1[10], arg2[64], arg3[32]
		read_args(args, 100)
		remove_quotes(args)
		parse(args, arg1, 100, arg2, 63, arg3, 31)
		if(!arg2[0] || !arg3[0])
		{
			colorchat(id, "!t[Money Manager] !gUsage: !nsay !t/transfer <username or #userid> <money>")
			return PLUGIN_HANDLED
		}
		
		new player = cmd_target(id, arg2, 0)
		if(!player)
		{
			colorchat(id, "!t[Money Manager] !gPlayer not found!")
			return PLUGIN_HANDLED
		}
		if(get_user_team(id) != get_user_team(player))
		{
			colorchat(id, "!t[Money Manager] !You can transfer money !tonly to teammates!g!")
			return PLUGIN_HANDLED
		}
		
		if(player == id)
		{
			colorchat(id, "!t[Money Manager] !gYou can not transfer money to yourself!")
			return PLUGIN_HANDLED
		}
		
		if(!is_str_num(arg3))
		{
			colorchat(id, "!t[Money Manager] !tThis is not a valid money amount!")
			return PLUGIN_HANDLED
		}
		
		new money_transfer = str_to_num(arg3)
		
		transfering[id] = true
		transfering[player] = true
		
		new name1[64], name2[64]
		get_user_name(id, name1, 63)
		get_user_name(player, name2, 63)
		if(money_transfer >= money[id])
		{
			colorchat(id, "!t[Money Manager] !gAll your money (!t$%i!g) is transfered to !t%s!g!", money[id], name2)
			colorchat(player, "!t[Money Manager] !t%s !gtransfered all his money (!t$%i!g) to you!", name1, money[id])
			money[player] += money[id]
			if(money[player] > get_pcvar_num(cvar_maxmoney))
			{
				money[player] = get_pcvar_num(cvar_maxmoney)
			}
			if(money[player] <= 8000)
			{
				cs_set_user_money(player, money[player])
			}
			else
			{
				cs_set_user_money(player, 8000)
			}
			update_hud_money(player, money[id], 1)
			update_hud_money(player, money[player], 0)
			money[id] = 0
			cs_set_user_money(id, 0)
			update_hud_money(id, -money[id], 1)
			update_hud_money(id, money[id], 0)
		}
		else
		{
			colorchat(id, "!t[Money Manager] !t$%i !gis transfered to !t%s!g!", money_transfer, name2)
			colorchat(player, "!t[Money Manager] !t%s !gtransfered to you !t$%i!g!", name1, money_transfer)
			money[player] += money_transfer
			if(money[player] > get_pcvar_num(cvar_maxmoney))
			{
				money[player] = get_pcvar_num(cvar_maxmoney)
			}
			if(money[player] <= 8000)
			{
				cs_set_user_money(player, money[player])
			}
			else
			{
				cs_set_user_money(player, 8000)
			}
			update_hud_money(player, money_transfer, 1)
			update_hud_money(player, money[player], 0)
			money[id] -= money_transfer
			update_hud_money(id, -money_transfer, 1)
			update_hud_money(id, money[id], 0)
			if(money[id] <= 8000)
			{
				cs_set_user_money(id, money[id])
			}
			else
			{
				cs_set_user_money(id, 8000)
			}
		}
		
		transfering[id] = false
		transfering[player] = false
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

// colored chat
colorchat(id, const msg[], any:...)
{
	new message[256]
	vformat(message, 255, msg, 3)
	
	replace_all(message, 255, "!n", "^x01")
	replace_all(message, 255, "!t", "^x03")
	replace_all(message, 255, "!g", "^x04")
	
	if(id == 0)
	{
		new maxplayers = get_maxplayers()
		for(new i = 1; i <= maxplayers; i++)
		{
			if(is_user_connected(i))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), {0,0,0}, i)
				write_byte(i)
				write_string(message)
				message_end()
			}
		}
	}
	else
	{
		if(is_user_connected(id))
		{
			message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), {0,0,0}, id)
			write_byte(id)
			write_string(message)
			message_end()
		}
	}
}